# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class CreateOrUpdateTrustedIdProviderParameters(Model):
    """The parameters used to create a new trusted identity provider.

    All required parameters must be populated in order to send to Azure.

    :param id_provider: Required. The URL of this trusted identity provider.
    :type id_provider: str
    """

    _validation = {
        'id_provider': {'required': True},
    }

    _attribute_map = {
        'id_provider': {'key': 'properties.idProvider', 'type': 'str'},
    }

    def __init__(self, *, id_provider: str, **kwargs) -> None:
        super(CreateOrUpdateTrustedIdProviderParameters, self).__init__(**kwargs)
        self.id_provider = id_provider
