# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class UpdateVirtualNetworkRuleWithAccountParameters(Model):
    """The parameters used to update a virtual network rule while updating a Data
    Lake Store account.

    All required parameters must be populated in order to send to Azure.

    :param name: Required. The unique name of the virtual network rule to
     update.
    :type name: str
    :param subnet_id: The resource identifier for the subnet.
    :type subnet_id: str
    """

    _validation = {
        'name': {'required': True},
    }

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'subnet_id': {'key': 'properties.subnetId', 'type': 'str'},
    }

    def __init__(self, *, name: str, subnet_id: str=None, **kwargs) -> None:
        super(UpdateVirtualNetworkRuleWithAccountParameters, self).__init__(**kwargs)
        self.name = name
        self.subnet_id = subnet_id
