# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.paging import Paged


class OperationMetadataPaged(Paged):
    """
    A paging container for iterating over a list of :class:`OperationMetadata <azure.mgmt.devtestlabs.models.OperationMetadata>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[OperationMetadata]'}
    }

    def __init__(self, *args, **kwargs):

        super(OperationMetadataPaged, self).__init__(*args, **kwargs)
class LabPaged(Paged):
    """
    A paging container for iterating over a list of :class:`Lab <azure.mgmt.devtestlabs.models.Lab>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Lab]'}
    }

    def __init__(self, *args, **kwargs):

        super(LabPaged, self).__init__(*args, **kwargs)
class LabVhdPaged(Paged):
    """
    A paging container for iterating over a list of :class:`LabVhd <azure.mgmt.devtestlabs.models.LabVhd>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[LabVhd]'}
    }

    def __init__(self, *args, **kwargs):

        super(LabVhdPaged, self).__init__(*args, **kwargs)
class SchedulePaged(Paged):
    """
    A paging container for iterating over a list of :class:`Schedule <azure.mgmt.devtestlabs.models.Schedule>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Schedule]'}
    }

    def __init__(self, *args, **kwargs):

        super(SchedulePaged, self).__init__(*args, **kwargs)
class ArtifactSourcePaged(Paged):
    """
    A paging container for iterating over a list of :class:`ArtifactSource <azure.mgmt.devtestlabs.models.ArtifactSource>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ArtifactSource]'}
    }

    def __init__(self, *args, **kwargs):

        super(ArtifactSourcePaged, self).__init__(*args, **kwargs)
class ArmTemplatePaged(Paged):
    """
    A paging container for iterating over a list of :class:`ArmTemplate <azure.mgmt.devtestlabs.models.ArmTemplate>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ArmTemplate]'}
    }

    def __init__(self, *args, **kwargs):

        super(ArmTemplatePaged, self).__init__(*args, **kwargs)
class ArtifactPaged(Paged):
    """
    A paging container for iterating over a list of :class:`Artifact <azure.mgmt.devtestlabs.models.Artifact>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Artifact]'}
    }

    def __init__(self, *args, **kwargs):

        super(ArtifactPaged, self).__init__(*args, **kwargs)
class CustomImagePaged(Paged):
    """
    A paging container for iterating over a list of :class:`CustomImage <azure.mgmt.devtestlabs.models.CustomImage>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[CustomImage]'}
    }

    def __init__(self, *args, **kwargs):

        super(CustomImagePaged, self).__init__(*args, **kwargs)
class FormulaPaged(Paged):
    """
    A paging container for iterating over a list of :class:`Formula <azure.mgmt.devtestlabs.models.Formula>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Formula]'}
    }

    def __init__(self, *args, **kwargs):

        super(FormulaPaged, self).__init__(*args, **kwargs)
class GalleryImagePaged(Paged):
    """
    A paging container for iterating over a list of :class:`GalleryImage <azure.mgmt.devtestlabs.models.GalleryImage>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[GalleryImage]'}
    }

    def __init__(self, *args, **kwargs):

        super(GalleryImagePaged, self).__init__(*args, **kwargs)
class NotificationChannelPaged(Paged):
    """
    A paging container for iterating over a list of :class:`NotificationChannel <azure.mgmt.devtestlabs.models.NotificationChannel>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[NotificationChannel]'}
    }

    def __init__(self, *args, **kwargs):

        super(NotificationChannelPaged, self).__init__(*args, **kwargs)
class PolicyPaged(Paged):
    """
    A paging container for iterating over a list of :class:`Policy <azure.mgmt.devtestlabs.models.Policy>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Policy]'}
    }

    def __init__(self, *args, **kwargs):

        super(PolicyPaged, self).__init__(*args, **kwargs)
class UserPaged(Paged):
    """
    A paging container for iterating over a list of :class:`User <azure.mgmt.devtestlabs.models.User>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[User]'}
    }

    def __init__(self, *args, **kwargs):

        super(UserPaged, self).__init__(*args, **kwargs)
class DiskPaged(Paged):
    """
    A paging container for iterating over a list of :class:`Disk <azure.mgmt.devtestlabs.models.Disk>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Disk]'}
    }

    def __init__(self, *args, **kwargs):

        super(DiskPaged, self).__init__(*args, **kwargs)
class DtlEnvironmentPaged(Paged):
    """
    A paging container for iterating over a list of :class:`DtlEnvironment <azure.mgmt.devtestlabs.models.DtlEnvironment>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[DtlEnvironment]'}
    }

    def __init__(self, *args, **kwargs):

        super(DtlEnvironmentPaged, self).__init__(*args, **kwargs)
class SecretPaged(Paged):
    """
    A paging container for iterating over a list of :class:`Secret <azure.mgmt.devtestlabs.models.Secret>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Secret]'}
    }

    def __init__(self, *args, **kwargs):

        super(SecretPaged, self).__init__(*args, **kwargs)
class ServiceFabricPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ServiceFabric <azure.mgmt.devtestlabs.models.ServiceFabric>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ServiceFabric]'}
    }

    def __init__(self, *args, **kwargs):

        super(ServiceFabricPaged, self).__init__(*args, **kwargs)
class LabVirtualMachinePaged(Paged):
    """
    A paging container for iterating over a list of :class:`LabVirtualMachine <azure.mgmt.devtestlabs.models.LabVirtualMachine>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[LabVirtualMachine]'}
    }

    def __init__(self, *args, **kwargs):

        super(LabVirtualMachinePaged, self).__init__(*args, **kwargs)
class VirtualNetworkPaged(Paged):
    """
    A paging container for iterating over a list of :class:`VirtualNetwork <azure.mgmt.devtestlabs.models.VirtualNetwork>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[VirtualNetwork]'}
    }

    def __init__(self, *args, **kwargs):

        super(VirtualNetworkPaged, self).__init__(*args, **kwargs)
