# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------

from enum import Enum
from azure.core import CaseInsensitiveEnumMeta


class ResourceStatus(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """The status of the resource regarding a single assessment."""

    HEALTHY = "Healthy"
    """This assessment on the resource is healthy"""
    NOT_APPLICABLE = "NotApplicable"
    """This assessment is not applicable to this resource"""
    OFF_BY_POLICY = "OffByPolicy"
    """This assessment is turned off by policy on this subscription"""
    NOT_HEALTHY = "NotHealthy"
    """This assessment on the resource is not healthy"""
